diff --git a/src/map.c b/src/map.c
index be3ead6..6ddef8b 100644
--- a/src/map.c
+++ b/src/map.c
@@ -17,247 +17,819 @@
  * along with GNU Robots.  If not, see <http://www.gnu.org/licenses/>.
  */
 
-#include <unistd.h>     /* for getopt */
-#include <stdio.h>
-#include <string.h>     /* for strdup */
-
+#include <gio/gio.h>
 #include <glib.h>
 
 #include "configs.h"
 #include "map.h"
 
-G_DEFINE_TYPE(Map, map, G_TYPE_OBJECT)
+struct _MapPrivate
+{
+  MapLoc 	**_map;
+  gint          max_x;
+  gint          max_y;
+  gboolean      mass_update;
+  gchar         *map_filename;
+  GSList        *robot_starting_locs;
+};
+
+enum map_properties
+  {
+   MAP_PROP_ZERO,
+   MAP_PROP_MAX_X,
+   MAP_PROP_MAX_Y,
+   MAP_PROP_LAST_PROP
+  };
+
+G_DEFINE_TYPE(Map, map, G_TYPE_OBJECT);
 
 enum
 {
-  ARG_0,
-  ARG_SIZE
+ MAP_UPDATE,
+ MAP_MOVE,
+ LAST_SIGNAL
 };
 
-static void map_set_property (GObject *object, guint prop_id,
-                  const GValue *value, GParamSpec *pspec);
+static guint map_signals[LAST_SIGNAL] = {0};
+static gboolean map_update_signal_set = FALSE;
+
+struct _MapThing
+{
+  gchar    thing_type;
+  gint     thing_orientation;
+  gpointer thing;
+};
+typedef struct _MapThing MapThing;
 
-static void map_get_property (GObject *object, guint prop_id,
-                  GValue *value, GParamSpec *pspec);
+struct _MapLoc
+{
+  gboolean  is_wall;
+  MapThing* thing;
+};
+typedef struct _MapLoc MapLoc;
 
 static void
-map_class_init (MapClass *klass)
+map_constructed (GObject *obj)
 {
-  GObjectClass *gobject_class;
+  /* update the object state depending on constructor properties */
 
-  gobject_class = G_OBJECT_CLASS(klass);
+  /* Always chain up to the parent constructed function to complete object
+   * initialisation. */
+  G_OBJECT_CLASS (map_parent_class)->constructed (obj);
+}
 
-  gobject_class->set_property = map_set_property;
-  gobject_class->get_property = map_get_property;
+static void
+map_finalize (GObject *obj)
+{
+  Map *self = MAP (obj);
+
+  g_free (self->priv->map_filename);
 
-  g_object_class_install_property (G_OBJECT_CLASS (klass), ARG_SIZE,
-                   g_param_spec_pointer ("size",
-                             "Size",
-                             "The size of the map",
-                             G_PARAM_READWRITE |
-                             G_PARAM_CONSTRUCT));
+  /* Free the map if any */
+  if (self->priv->_map != NULL)
+    {
+      for (guint x = 0; x < map_get_max_x(self); x++)
+	{
+	  g_free (self->priv->_map[x]);
+	}
+      g_free (self->priv->_map);
+    }
+
+  g_slist_free_full(self->priv->robot_starting_locs, g_free);
+  self->priv->robot_starting_locs = NULL;
+  g_free(self->priv);
+  /* Always chain up to the parent finalize function to complete object
+   * destruction. */
+  G_OBJECT_CLASS (map_parent_class)->finalize (obj);
 }
 
 static void
-map_init (Map *map)
+map_set_property(GObject *object, guint prop_id, const GValue *value,
+	GParamSpec *pspec)
 {
-  map->_map = NULL;
-  map->size.num_rows = -1;
-  map->size.num_cols = -1;
+  Map *map;
+
+  /* it's not null if we got it, but it might not be ours */
+  g_return_if_fail(G_IS_MAP(object));
+
+  map = MAP(object);
+
+  switch (prop_id)
+    {
+    case MAP_PROP_MAX_X:
+      map->priv->max_x = g_value_get_int(value);
+      break;
+    case MAP_PROP_MAX_Y:
+      map->priv->max_y = g_value_get_int(value);
+      break;
+    default:
+      G_OBJECT_WARN_INVALID_PROPERTY_ID(object, prop_id, pspec);
+      break;
+    }
 }
 
-/* fload_map - loads a map file into memory. */
 static void
-fload_map (Map *map, FILE *stream)
+map_get_property(GObject *object, guint prop_id, GValue *value,
+	GParamSpec *pspec)
 {
-  gint ch;
-  gint i, j;
+  Map *map;
 
-  /* Read the map file */
-  i = 0;
-  j = 0;
+  /* it's not null if we got it, but it might not be ours */
+  g_return_if_fail(G_IS_MAP(object));
 
-  while ((ch = fgetc (stream)) != EOF)
-  {
-    /* Add the ch to the map */
-    switch (ch)
-    {
-    case SPACE:
-    case WALL:
-    case BADDIE:
-    case PRIZE:
-    case FOOD:
-      map->_map[j][i] = ch;
-      break;
+  map = MAP(object);
 
-    case '\n':
-      /* ignore the newline */
+  switch (prop_id)
+    {
+    case MAP_PROP_MAX_X:
+      g_value_set_int(value, map->priv->max_x);
+      break;
+    case MAP_PROP_MAX_Y:
+      g_value_set_int(value, map->priv->max_y);
       break;
-
     default:
-      /* not a valid map char, but we'll add a space anyway */
-      map->_map[j][i] = SPACE;
+      G_OBJECT_WARN_INVALID_PROPERTY_ID(object, prop_id, pspec);
       break;
-    }               /* switch */
+    }
+}
+
+void
+map_class_init (MapClass *klass)
+{
+  GObjectClass *gobject_class;
 
-    /* Check for newline */
-    if (ch == '\n')
+  gobject_class = G_OBJECT_CLASS(klass);
+  gobject_class->constructed = map_constructed;
+  gobject_class->finalize = map_finalize;
+  gobject_class->set_property = map_set_property;
+  gobject_class->get_property = map_get_property;
+
+  g_object_class_install_property
+    (G_OBJECT_CLASS(klass), MAP_PROP_MAX_X,
+     g_param_spec_int("max_x",
+		      "Maximum X",
+		      "Maximum X-value for the map.",
+		      0, G_MAXINT, DEFAULT_MAP_COLUMNS,
+		      G_PARAM_READWRITE | G_PARAM_CONSTRUCT));
+  g_object_class_install_property
+    (G_OBJECT_CLASS(klass), MAP_PROP_MAX_Y,
+     g_param_spec_int("max_y",
+		      "Maximum Y",
+		      "Maximum Y-value for the map.",
+		      0, G_MAXINT, DEFAULT_MAP_ROWS,
+		      G_PARAM_READWRITE | G_PARAM_CONSTRUCT));
+
+  map_signals[MAP_UPDATE] =
+    g_signal_new("map-update",
+		 G_TYPE_MAP,
+		 G_SIGNAL_ACTION,
+		 0,
+                 NULL /* accumulator */,
+                 NULL /* accumulator data */,
+                 NULL /* C marshaller */,
+                 G_TYPE_NONE /* return_type */,
+                 0     /* n_params */,
+                 NULL  /* param_types */);
+  map_signals[MAP_MOVE] =
+    g_signal_new("map-move",
+		 G_TYPE_MAP,
+		 G_SIGNAL_ACTION,
+		 0,
+                 NULL /* accumulator */,
+                 NULL /* accumulator data */,
+                 NULL /* C marshaller */,
+                 G_TYPE_NONE /* return_type */,
+                 1     /* n_params */,
+                 G_TYPE_POINTER  /* param_types */);
+  map_update_signal_set = TRUE;
+}
+
+gboolean
+map_init_map(Map *self)
+{
+  g_return_val_if_fail(G_IS_MAP(self), FALSE);
+  g_return_val_if_fail(NULL != self, FALSE);
+
+  g_slist_free_full(self->priv->robot_starting_locs, g_free);
+  self->priv->robot_starting_locs = NULL;
+  if(NULL != self->priv->map_filename)
     {
-      /* the line may have ended early.  pad with WALL */
-      while (i < map->size.num_cols)
-      {
-        map->_map[j][i++] = WALL;
-      }
+      g_free(self->priv->map_filename);
+      self->priv->map_filename = NULL;
     }
 
-    /* if newline */
-    /* Check for limits on map */
-    if (++i >= map->size.num_cols)
+  gint max_x = map_get_max_x(self);
+  gint max_y = map_get_max_y(self);
+  if(max_x == 0 || max_y == 0) {
+    g_error("map_init_map: attempt to initialize map before setting max_x (%d) and max_y (%d).", max_x, max_y);
+    return(FALSE);
+  }
+
+  /* Free the map if any */
+  if (self->priv->_map != NULL)
     {
-      /* We have filled this line */
-      ++j;
-      i = 0;
+      for (guint x = 0; x < max_x; x++)
+	{
+	  g_free (self->priv->_map[x]);
+	}
+      g_free (self->priv->_map);
+    }
 
-      /* Flush the buffer for this line */
-      while (ch != '\n')
-      {
-        ch = fgetc (stream);
-      }
+  /* Allocate the map structure according to the new size */
+  self->priv->_map = g_malloc0 (max_x * sizeof (MapLoc **));
+
+  for (guint x = 0; x < max_x; x++)
+    {
+      self->priv->_map[x] = g_malloc0 (max_y * sizeof (MapLoc));
     }
-    /* if i */
-    if (j >= map->size.num_rows)
+
+  /* Set Reasonable Starting Values (all walls) */
+  self->priv->mass_update = TRUE;
+  for (guint x = 0; x < max_x; x++)
     {
-      /* the map is filled */
-      return;
+      for (guint y = 0; y < max_y; y++)
+	{
+	  map_set_loc(self, x, y, TRUE);
+	}
     }
-  }             /* while fgetc */
+  self->priv->mass_update = FALSE;
+  return(TRUE);
+}
 
-  /* After the loop, we are done reading the map file.  Make sure this
-     is bounded by WALL. */
-  if (i > 0)
-  {
-    ++j;
-  }
+void
+map_init (Map *self)
+{
+  self->priv = g_malloc(sizeof(MapPrivate));
+  self->priv->_map = NULL;
+  self->priv->max_x = 0;
+  self->priv->max_y = 0;
+  self->priv->mass_update = FALSE;
+  self->priv->map_filename = NULL;
+  self->priv->robot_starting_locs = NULL;
+}
 
-  for (i = 0; i < map->size.num_cols; i++)
-  {
-    map->_map[j][i] = WALL;
-  }
+gboolean
+map_remove_thing(Map *self, gint x, gint y)
+{
+  g_return_val_if_fail(G_IS_MAP(self), FALSE);
+  g_return_val_if_fail(NULL != self, FALSE);
+
+  gboolean retval = FALSE;
+  if(x >= 0 && x < map_get_max_x(self) &&
+     y >= 0 && y < map_get_max_y(self))
+    {
+      g_free(self->priv->_map[x][y].thing);
+      self->priv->_map[x][y].thing = NULL;
+      retval = TRUE;
+    }
+  else
+    {
+      g_error("Map reference out of range x: %d (max %d); y: %d (max %d)\n",
+	      x, map_get_max_x(self), y, map_get_max_y(self));
+    }
+
+  if(retval && ! self->priv->mass_update)
+    g_signal_emit(self, map_signals[MAP_UPDATE], 0 /* details */);
+  return retval;
 }
 
-static void
-cleanup_map (Map *map)
+gboolean
+map_place_thing(Map *self, gint x, gint y,
+		gint thing_type, gint orientation, gpointer thing)
 {
-  gint i, j;
+  g_return_val_if_fail(G_IS_MAP(self), FALSE);
+  g_return_val_if_fail(NULL != self, FALSE);
 
-  /* make sure there is a wall at top/bottom */
-  for (i = 0; i < map->size.num_cols; i++)
-  {
-    map->_map[0][i] = WALL;
-    map->_map[map->size.num_rows - 1][i] = WALL;
-  }
+  gboolean retval = FALSE;
+  if(x >= 0 && x < map_get_max_x(self) &&
+     y >= 0 && y < map_get_max_y(self))
+    {
+      if(self->priv->_map[x][y].thing == NULL)
+	{
+	  self->priv->_map[x][y].thing = g_malloc(sizeof(MapThing));
+	}
+      self->priv->_map[x][y].thing->thing_type = thing_type;
+      self->priv->_map[x][y].thing->thing_orientation = orientation;
+      self->priv->_map[x][y].thing->thing = thing;
+      retval = TRUE;
+    }
+  else
+    {
+      g_error("Map reference out of range x: %d (max %d); y: %d (max %d)\n",
+	      x, map_get_max_x(self), y, map_get_max_y(self));
+    }
 
-  /* make sure there is a wall at left/right */
-  for (j = 0; j < map->size.num_rows; j++)
-  {
-    map->_map[j][0] = WALL;
-    map->_map[j][map->size.num_cols - 1] = WALL;
-  }
+  if(retval && ! self->priv->mass_update)
+    g_signal_emit(self, map_signals[MAP_UPDATE], 0 /* details */);
+  return retval;
 }
 
-static void
-map_set_property (GObject *object, guint prop_id,
-          const GValue *value, GParamSpec *pspec)
+gboolean
+map_set_loc(Map *self, gint x, gint y, gboolean is_wall)
 {
-  Map *map;
-  guint i;
+  g_return_val_if_fail(G_IS_MAP(self), FALSE);
+  g_return_val_if_fail(NULL != self, FALSE);
 
-  /* it's not null if we got it, but it might not be ours */
-  g_return_if_fail (G_IS_MAP (object));
+  gboolean retval = TRUE;
 
-  map = MAP (object);
+  if(x >= 0 && x < map_get_max_x(self) &&
+     y >= 0 && y < map_get_max_y(self))
+    {
+      self->priv->_map[x][y].is_wall = is_wall ? TRUE : FALSE;
+    }
+  else
+    {
+      g_error("Map reference out of range x: %d (max %d); y: %d (max %d)\n",
+	      x, map_get_max_x(self), y, map_get_max_y(self));
+      retval = FALSE;
+    }
 
-  switch (prop_id)
-  {
-  case ARG_SIZE:
-    /* Free the map if any */
-    if (map->_map != NULL)
+  if(retval && ! self->priv->mass_update)
+    g_signal_emit(self, map_signals[MAP_UPDATE], 0 /* details */);
+  return(retval);
+}
+
+gboolean
+map_move(Map *self, gint origin_x, gint origin_y, gint dest_x, gint dest_y)
+{
+  g_return_val_if_fail(G_IS_MAP(self), FALSE);
+
+  if(origin_x < 0 || origin_x >= self->priv->max_x ||
+     origin_y < 0 || origin_y >= self->priv->max_y ||
+     dest_x < 0 || dest_x >= self->priv->max_x ||
+     dest_y < 0 || dest_y >= self->priv->max_y)
+    return(FALSE);
+
+  self->priv->mass_update = TRUE;
+  gboolean retval = FALSE;
+  g_free(self->priv->_map[dest_x][dest_y].thing);
+  self->priv->_map[dest_x][dest_y].thing = self->priv->_map[origin_x][origin_y].thing;
+  self->priv->_map[origin_x][origin_y].thing = NULL;
+  retval = TRUE;
+
+  if(retval)
     {
-      for (i = 0; i < map->size.num_rows; i++)
-      {
-        g_free (map->_map[i]);
-      }
+      MapMove *move = g_malloc(sizeof(MapMove));
+
+      move->thing = map_get_loc(self, dest_x, dest_y);
+      move->origin_x = origin_x;
+      move->origin_y = origin_y;
+      move->dest_x = dest_x;
+      move->dest_y = dest_y;
+      g_signal_emit(self, map_signals[MAP_MOVE], 0, move);
+      g_free(move); // Assume handlers copy move
+    }
+  self->priv->mass_update = FALSE;
+
+  return(retval);
+}
+
+gboolean
+map_get_loc(Map *self, gint x, gint y)
+{
+  g_return_val_if_fail(G_IS_MAP(self), -1);
+  g_return_val_if_fail(NULL != self, -1);
+
+  if(x >= 0 && x < map_get_max_x(self) &&
+     y >= 0 && y < map_get_max_y(self))
+    {
+      return(self->priv->_map[x][y].is_wall);
+    }
+  else
+    {
+      g_printerr("Map reference out of range x: %d (max %d); y: %d (max %d)\n",
+		 x, map_get_max_x(self), y, map_get_max_y(self));
+      exit(EXIT_FAILURE);
+    }
+}
 
-      g_free (map->_map);
+gint
+map_get_thing_orientation(Map *self, gint x, gint y)
+{
+  g_return_val_if_fail(G_IS_MAP(self), -1);
+  g_return_val_if_fail(NULL != self, -1);
+
+  if(x >= 0 && x < map_get_max_x(self) &&
+     y >= 0 && y < map_get_max_y(self))
+    {
+      if(NULL == self->priv->_map[x][y].thing)
+	{
+	  g_warning("map_get_thing_orientation: orientation requested for location that does not have anything in it (%d, %d)", x, y);
+	  return(-1);
+	}
+      else
+	{
+	  return(self->priv->_map[x][y].thing->thing_orientation);
+	}
+    }
+  else
+    {
+      g_printerr("Map reference out of range x: %d (max %d); y: %d (max %d)\n",
+		 x, map_get_max_x(self), y, map_get_max_y(self));
+      exit(EXIT_FAILURE);
     }
+}
+
+gboolean
+map_find_thing(Map *self, gpointer thing, gint* x, gint *y, gint *orientation)
+{
+  g_return_val_if_fail(G_IS_MAP(self), -1);
+  g_return_val_if_fail(NULL != self, -1);
+
+  if(NULL == thing)
+    return FALSE; // Not being asked to do anything
 
-    /* Get the new size of the map */
-    g_memmove (&map->size, g_value_get_pointer (value), sizeof (MapSize));
+  gboolean found = FALSE;
+  for(gint iter_x = 0; iter_x < map_get_max_x(self) && ! found; iter_x++)
+    {
+      for(gint iter_y = 0; iter_y < map_get_max_y(self) && ! found; iter_y++)
+	{
+	  if(NULL != self->priv->_map[iter_x][iter_y].thing)
+	    {
+	      if(thing == self->priv->_map[iter_x][iter_y].thing->thing)
+		{
+		  found = TRUE;
+		  if(NULL != x)
+		    *x = iter_x;
+		  if(NULL != y)
+		    *y = iter_y;
+		  if(NULL != orientation)
+		    *orientation =
+		      map_get_thing_orientation(self, iter_x, iter_y);
+		}
+	    }
+	}
+    }
+  return found;
+}
 
-    /* Allocate the according to the new size */
-    map->_map = g_malloc (map->size.num_rows * sizeof (gint **));
+gint
+map_compute_clockwise_turn(gint orientation, gint num_turns)
+{
+  if(orientation < 0 || orientation > 3)
+    g_warning("map_compute_clockwise_turn given an out of range orientation %d", orientation);
 
-    for (i = 0; i < map->size.num_rows; i++)
+  gint new_dir = (orientation + num_turns) % 4;
+  if (new_dir < 0)
     {
-      map->_map[i] = g_malloc (map->size.num_cols * sizeof (gint));
+      /* Get a positive orientation by doing a full 4 turns clockwise */
+      new_dir = new_dir + 4;
     }
+  g_assert(new_dir >= 0 && new_dir < 4);
 
-    break;
-  default:
-    G_OBJECT_WARN_INVALID_PROPERTY_ID (object, prop_id, pspec);
-    break;
-  }
+  return new_dir;
 }
 
+gboolean
+map_thing_turn_clockwise(Map *self, gint x, gint y, gint num_turns)
+{
+  g_return_val_if_fail(G_IS_MAP(self), FALSE);
+
+  gint orientation = map_get_thing_orientation(self, x, y);
+
+  if(-1 == orientation)
+    return FALSE; // Did not find anything to rotate in this location.
+
+  if(num_turns == 0)
+    return TRUE;
+
+  self->priv->_map[x][y].thing->thing_orientation = map_compute_clockwise_turn(orientation, num_turns);
+
+  // TODO: mod the update signal to say what got update to reduce map redraws
+  g_signal_emit(self, map_signals[MAP_UPDATE], 0 /* details */);
+
+  return TRUE;
+}
+
+gchar
+map_get_loc_thing_char(Map *self, gint x, gint y)
+{
+  g_return_val_if_fail(G_IS_MAP(self), -1);
+  g_return_val_if_fail(NULL != self, -1);
+
+  if(x >= 0 && x < map_get_max_x(self) &&
+     y >= 0 && y < map_get_max_y(self))
+    {
+      if(NULL == self->priv->_map[x][y].thing)
+	{
+	  if(map_get_loc(self, x, y))
+	    return(WALL);
+	  else
+	    return(SPACE);
+	}
+      else
+	{
+	  return(self->priv->_map[x][y].thing->thing_type);
+	}
+    }
+  else
+    {
+      g_error("Map reference out of range x: %d (max %d); y: %d (max %d)\n",
+		 x, map_get_max_x(self), y, map_get_max_y(self));
+      return -1;
+    }
+}
+
+/* fload_map - loads a map file into memory. */
 static void
-map_get_property (GObject *object, guint prop_id,
-          GValue *value, GParamSpec *pspec)
+map_load_stream (Map *self, GFileInputStream *stream, GError **error)
 {
-  Map *map;
+  g_return_if_fail(G_IS_MAP (self));
 
-  /* it's not null if we got it, but it might not be ours */
-  g_return_if_fail (G_IS_MAP (object));
+  gint row = 0, col = 0;
 
-  map = MAP (object);
+  gint max_x = map_get_max_x(self);
+  gint max_y = map_get_max_y(self);
 
-  switch (prop_id)
+  self->priv->mass_update = TRUE;
+  /* Read the map file */
+  gssize bytesread;
+  gchar buffer[1] = "\0";
+  GError *inner_error = NULL;
+  while ((bytesread = g_input_stream_read (G_INPUT_STREAM(stream), buffer, 1, NULL, &inner_error)) > 0)
   {
-  case ARG_SIZE:
-    g_value_set_pointer (value, g_memdup (&map->size, sizeof (MapSize)));
-    break;
-  default:
-    G_OBJECT_WARN_INVALID_PROPERTY_ID (object, prop_id, pspec);
-    break;
-  }
+    if(NULL != inner_error)
+      {
+	g_error("map_load_stream: Failure to read from GFileInputStream.");
+	g_propagate_error(error, inner_error);
+	break;
+      }
+    else if(buffer[0] == '\n')
+      {
+	++row;
+	col = 0;
+      }
+    else if(col >= max_x)
+      {
+	// flush data past the max col size of the map
+      }
+    else
+      {
+	switch(buffer[0])
+	  {
+	  case SPACE:
+	    map_set_loc(self, col, row, FALSE);
+	    map_remove_thing(self, col, row);
+	    break;
+	  case WALL:
+	    map_set_loc(self, col, row, TRUE);
+	    map_remove_thing(self, col, row);
+	    break;
+	  case BADDIE:
+	  case PRIZE:
+	  case FOOD:
+	    map_set_loc(self, col, row, FALSE);
+	    map_place_thing(self, col, row, buffer[0], NORTH, NULL);
+	    break;
+	  case ROBOT:
+	    map_set_loc(self, col, row, FALSE);
+	    /* Add to a list to be used by map_auto_place_robot later */
+	    MapCoords *coords = g_malloc(sizeof(MapCoords));
+	    coords->x = col;
+	    coords->y = row;
+	    self->priv->robot_starting_locs =
+	      g_slist_append(self->priv->robot_starting_locs, coords);
+	    break;
+	  default:
+	    g_error("map_load_stream: Unknown character in file: %d", buffer[0]);
+	    map_set_loc(self, col, row, FALSE);
+	    map_remove_thing(self, col, row);
+	  }
+	++col;
+      }
+    if (row >= max_y) /* the map is filled */
+      break;
+  }             /* while fgetc */
+  self->priv->mass_update = FALSE;
+}
+
+gint
+map_get_max_x(Map *self)
+{
+  g_return_val_if_fail(G_IS_MAP (self), -1);
+
+  return(self->priv->max_x);
+}
+
+gint
+map_get_max_y(Map *self)
+{
+  g_return_val_if_fail(G_IS_MAP (self), -1);
+
+  return(self->priv->max_y);
 }
 
 Map *
-map_new_from_file (const gchar *map_file, gint num_rows, gint num_cols)
+map_new_blank (gint num_rows, gint num_cols)
 {
-  Map *map;
-  FILE *stream;
-  MapSize size;
+  if(num_rows < 1 || num_cols < 1)
+    {
+      g_error("map_new_blank: invalid values given for num_rows and/or num_cols (%d, %d)\n", num_rows, num_cols);
+      return(NULL);
+    }
+  
+  Map *map = MAP(g_object_new (map_get_type(),
+			       "max_x", num_cols,
+			       "max_y", num_rows,
+			       NULL));
+  map_init_map(map);
+
+  return(map);
+}
 
-  size.num_rows = num_rows;
-  size.num_cols = num_cols;
+gboolean
+map_load_filename (Map *self, const gchar *map_file, GError **error)
+{
+  g_return_val_if_fail(G_IS_MAP (self), FALSE);
+
+  if(map_get_max_x(self) == 0 || map_get_max_y(self) == 0) {
+    g_error("map_load_filename: attempt to load file before initializing max_x and max_y.");
+    return(FALSE);
+  }
+
+  map_init_map(self);
 
-  stream = fopen (map_file, "r");
+  GFile *file = g_file_new_for_path(map_file);
 
-  if (stream != NULL)
+  gboolean retval = FALSE;
+  GError *inner_error = NULL;
+  GFileInputStream *stream = g_file_read(file, NULL, &inner_error);
+  if (NULL == inner_error)
   {
-    /*map = MAP (g_object_new (map_get_type (), "size", &size, NULL));*/
-    map = MAP(g_object_new (map_get_type(), "size", &size, NULL));
-    fload_map (map, stream);
-    fclose (stream);
-    cleanup_map (map);
+    map_load_stream(self, stream, &inner_error);
+    g_input_stream_close (G_INPUT_STREAM(stream), NULL, NULL);
+    g_object_unref(stream);
 
-    return map;
+    if(NULL == inner_error)
+      {
+	self->priv->map_filename = g_strdup(map_file);
+	retval = TRUE;
+      }
+    else
+      {
+	g_propagate_error(error, inner_error);
+	retval = FALSE;
+      }
   }
-
-  /* else, no file to open */
-  else
+  else /* else, no file to open */
   {
-    g_warning ("Could not open map file: %s\n", map_file);
-    return NULL;
+    g_propagate_error(error, inner_error);
+    retval = FALSE;
   }
+  g_object_unref(file);
+
+  g_signal_emit(self, map_signals[MAP_UPDATE], 0 /* details */);
+  return retval;
+}
+
+gchar*
+map_get_filename(Map *self)
+{
+  g_return_val_if_fail(G_IS_MAP (self), NULL);
+
+  return(g_strdup(self->priv->map_filename));
+}
+
+/* Sequence of positive coords closest to origin given. */
+static MapCoords*
+map_iterate_pyramid(Map *self, gint x, gint y, gint max_x, gint max_y, gchar on_loc_thing_char)
+{
+  if(x > max_x && y > max_y)
+    return NULL;
+
+  if(x >= 0 && x < max_x &&
+     y >= 0 && y < max_y)
+    {
+      if(on_loc_thing_char == map_get_loc_thing_char(self, x, y))
+	{
+	  MapCoords *coords = g_malloc(sizeof(MapCoords));
+	  coords->x = x;
+	  coords->y = y;
+	  return coords;
+	}
+    }
+  if(x == 0)
+    {
+      return map_iterate_pyramid(self, y + 1, 0, max_x, max_y, on_loc_thing_char);
+    }
+  else
+    {
+      return map_iterate_pyramid(self, x - 1, y + 1, max_x, max_y, on_loc_thing_char);
+    }
+}
+
+gboolean
+map_auto_place_thing_on(Map *self, gint thing_char, gint orientation, gpointer thing, gchar on_loc_thing_char)
+{
+  g_return_val_if_fail(G_IS_MAP (self), FALSE);
+
+  MapCoords *coords = map_iterate_pyramid(self, 0, 0,
+					  map_get_max_x(self),
+					  map_get_max_y(self),
+					  on_loc_thing_char);
+
+  if(NULL != coords)
+    {
+      return map_place_thing(self, coords->x, coords->y, thing_char, orientation, thing);
+    }
+  else
+    {
+      return FALSE;
+    }
+}
+
+gboolean
+map_auto_place_robot(Map *self, gpointer robot)
+{
+  g_return_val_if_fail(G_IS_MAP (self), FALSE);
+
+  if(NULL == robot)
+    return FALSE;
+
+  gboolean retval = FALSE;
+  if(NULL != self->priv->robot_starting_locs)
+    { /* There are robot starting locs available in the map */
+      MapCoords *coords = g_slist_nth_data(self->priv->robot_starting_locs, 0);
+      if(ROBOT != map_get_loc_thing_char(self, 1, 1))
+	{
+	  self->priv->robot_starting_locs =
+	    g_slist_remove(self->priv->robot_starting_locs, coords);
+	  retval = map_place_thing(self, coords->x, coords->y,
+				   ROBOT, EAST, robot);
+	  g_free(coords);
+	  return retval;
+	}
+      else
+	{ /* There's already a robot there, so remove coords from
+	     robot_starting_locs and try again */
+	  self->priv->robot_starting_locs =
+	    g_slist_remove(self->priv->robot_starting_locs, coords);
+	  g_free(coords);
+	  retval = map_auto_place_robot(self, robot);
+	}
+    }
+  else
+    {
+      gchar place_priority[] = {SPACE, PRIZE, FOOD, BADDIE, '\0'};
+      for(gint priority = 0; place_priority[priority] != '\0'; priority++)
+	{
+	  if(map_auto_place_thing_on(self, ROBOT, EAST, robot, place_priority[priority]))
+	    return TRUE;
+	}
+    }
+
+  /* If all else fails, just put it in 1, 1 as long as there isn't
+     already a robot there */
+  if(ROBOT != map_get_loc_thing_char(self, 1, 1))
+    {
+      map_set_loc(self, 1, 1, FALSE); /* Make sure 1, 1 isn't a wall */
+      return map_place_thing(self, 1, 1, ROBOT, EAST, robot);
+    }
+  else
+    {
+      return FALSE;
+    }
+}
+
+gboolean
+map_compute_facing_coords(gint from_x, gint from_y, gint orientation, gint* facing_x, gint* facing_y)
+{
+  gboolean retval = FALSE;
+  if(NULL != facing_x)
+    *facing_x = -1;
+  if(NULL != facing_y)
+    *facing_y = -1;
+
+  switch (orientation)
+    {
+    case NORTH:				/* N */
+      if(NULL != facing_y)
+	*facing_y = from_y - 1;
+      if(NULL != facing_x)
+	*facing_x = from_x;
+      retval = TRUE;
+      break;
+    case EAST:					/* E */
+      if(NULL != facing_x)
+	*facing_x = from_x + 1;
+      if(NULL != facing_y)
+	*facing_y = from_y;
+      retval = TRUE;
+      break;
+    case SOUTH:				/* S */
+      if(NULL != facing_y)
+	*facing_y = from_y + 1;
+      if(NULL != facing_x)
+	*facing_x = from_x;
+      retval = TRUE;
+      break;
+    case WEST:					/* W */
+      if(NULL != facing_x)
+	*facing_x = from_x - 1;
+      if(NULL != facing_y)
+	*facing_y = from_y;
+      retval = TRUE;
+      break;
+    }
+  return retval;
 }
